#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include "qtimer.h"
#include "cv.h"
#include "highgui.h"
#include <QTime>
#include <string>
#include <QIcon>
#include <phonon/phonon>
#include <QMessageBox>
#include <QDir>

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow {
    Q_OBJECT
public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();

protected:
    void changeEvent(QEvent *e);

private:
    QTimer *timer;
    Ui::MainWindow *ui;
    CvCapture* capture;
    CvCapture* falstartCapture;
    IplImage* in;
    IplImage* CFIn;
    IplImage* out;
    IplImage* gray1;
    IplImage* gray2;
    IplImage* foreground;
    IplImage* total_moves;
    IplImage* video;
    QTime time;
    bool started;
    bool background;
    bool countdown;
    bool pause;
    int round_time;
    bool checkingFalstart;
    bool CFPaused;
    CvVideoWriter* writer;
    CvVideoWriter* tempWriter;
    CvFont* font;
    int kamera;
    int countdownFrames;

    QIcon play_icon;
    QIcon pause_icon;
    Phonon::MediaObject* start_signal;

    void display_time(int time);
    std::string time2string(int t);

public slots:
    void timerAction();
    void atStart();
    void at2minutes();
    void at3minutes();
    void atFalstart();
    void setCamera();
    void atPlay();
    void atSlider();
};

#endif // MAINWINDOW_H
